"""Client and server classes corresponding to protobuf-defined services."""
import grpc
import warnings
from . import cortex_api_pb2 as cortex__api__pb2
GRPC_GENERATED_VERSION = '1.68.1'
GRPC_VERSION = grpc.__version__
_version_not_supported = False
try:
    from grpc._utilities import first_version_is_lower
    _version_not_supported = first_version_is_lower(GRPC_VERSION, GRPC_GENERATED_VERSION)
except ImportError:
    _version_not_supported = True
if _version_not_supported:
    raise RuntimeError(f'The grpc package installed is at version {GRPC_VERSION},' + f' but the generated code in cortex_api_pb2_grpc.py depends on' + f' grpcio>={GRPC_GENERATED_VERSION}.' + f' Please upgrade your grpc module to grpcio>={GRPC_GENERATED_VERSION}' + f' or downgrade your generated code using grpcio-tools<={GRPC_VERSION}.')

class CortexApiStub(object):
    """Missing associated documentation comment in .proto file."""

    def __init__(self, channel):
        """Constructor.

        Args:
            channel: A grpc.Channel.
        """
        self.Call = channel.unary_unary('/cortex.axon.CortexApi/Call', request_serializer=cortex__api__pb2.CallRequest.SerializeToString, response_deserializer=cortex__api__pb2.CallResponse.FromString, _registered_method=True)

class CortexApiServicer(object):
    """Missing associated documentation comment in .proto file."""

    def Call(self, request, context):
        """Missing associated documentation comment in .proto file."""
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

def add_CortexApiServicer_to_server(servicer, server):
    rpc_method_handlers = {'Call': grpc.unary_unary_rpc_method_handler(servicer.Call, request_deserializer=cortex__api__pb2.CallRequest.FromString, response_serializer=cortex__api__pb2.CallResponse.SerializeToString)}
    generic_handler = grpc.method_handlers_generic_handler('cortex.axon.CortexApi', rpc_method_handlers)
    server.add_generic_rpc_handlers((generic_handler,))
    server.add_registered_method_handlers('cortex.axon.CortexApi', rpc_method_handlers)

class CortexApi(object):
    """Missing associated documentation comment in .proto file."""

    @staticmethod
    def Call(request, target, options=(), channel_credentials=None, call_credentials=None, insecure=False, compression=None, wait_for_ready=None, timeout=None, metadata=None):
        return grpc.experimental.unary_unary(request, target, '/cortex.axon.CortexApi/Call', cortex__api__pb2.CallRequest.SerializeToString, cortex__api__pb2.CallResponse.FromString, options, channel_credentials, insecure, call_credentials, compression, wait_for_ready, timeout, metadata, _registered_method=True)